//Source file: CallAppInfo.java
//Date: February 2007
//Generic Call Control for 1st draft ES 204 915-4-2 V1.1.1, DES/TISPAN-01032-04-2-OSA, Parlay 6.0

package org.csapi.jr.se.cc.gccs;

/**
 * Defines the Tagged Choice of Data Elements that specify application-related call information.
 *
 */
public final class CallAppInfo implements java.io.Serializable {

    private CallAppInfoType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new CallAppInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public CallAppInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a CallAppInfoType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public CallAppInfoType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a CallAppAdditionalAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getCallAppAdditionalAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_ADDITIONAL_ADDRESS) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a CallAppAdditionalAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setCallAppAdditionalAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallAppInfoType.CALL_APP_ADDITIONAL_ADDRESS;
        _object = value;
    }

    /**
     * This method returns a CallAppAlertingMechanism
     * 
     * @return  a int value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public int getCallAppAlertingMechanism() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_ALERTING_MECHANISM) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.Integer) _object).intValue());
    }

    /**
     * This method sets a CallAppAlertingMechanism
     * 
     * @param value a int value
     */
    public void setCallAppAlertingMechanism(int value) {
        _discriminator = CallAppInfoType.CALL_APP_ALERTING_MECHANISM;
        _object = new java.lang.Integer(value);
    }

    /**
     * This method returns a CallAppBearerService
     * 
     * @return  a org.csapi.jr.se.cc.CallBearerService value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallBearerService getCallAppBearerService() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_BEARER_SERVICE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallBearerService) _object);
    }

    /**
     * This method sets a CallAppBearerService
     * 
     * @param value a org.csapi.jr.se.cc.CallBearerService value
     */
    public void setCallAppBearerService(org.csapi.jr.se.cc.CallBearerService value) {
        _discriminator = CallAppInfoType.CALL_APP_BEARER_SERVICE;
        _object = value;
    }

    /**
     * This method returns a CallAppGenericInfo
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getCallAppGenericInfo() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_GENERIC_INFO) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a CallAppGenericInfo
     * 
     * @param value a java.lang.String value
     */
    public void setCallAppGenericInfo(java.lang.String value) {
        _discriminator = CallAppInfoType.CALL_APP_GENERIC_INFO;
        _object = value;
    }

    /**
     * This method returns a CallAppNetworkAccessType
     * 
     * @return  a org.csapi.jr.se.cc.CallNetworkAccessType value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallNetworkAccessType getCallAppNetworkAccessType() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_NETWORK_ACCESS_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallNetworkAccessType) _object);
    }

    /**
     * This method sets a CallAppNetworkAccessType
     * 
     * @param value a org.csapi.jr.se.cc.CallNetworkAccessType value
     */
    public void setCallAppNetworkAccessType(org.csapi.jr.se.cc.CallNetworkAccessType value) {
        _discriminator = CallAppInfoType.CALL_APP_NETWORK_ACCESS_TYPE;
        _object = value;
    }

    /**
     * This method returns a CallAppPartyCategory
     * 
     * @return  a org.csapi.jr.se.cc.CallPartyCategory value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallPartyCategory getCallAppPartyCategory() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_PARTY_CATEGORY) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallPartyCategory) _object);
    }

    /**
     * This method sets a CallAppPartyCategory
     * 
     * @param value a org.csapi.jr.se.cc.CallPartyCategory value
     */
    public void setCallAppPartyCategory(org.csapi.jr.se.cc.CallPartyCategory value) {
        _discriminator = CallAppInfoType.CALL_APP_PARTY_CATEGORY;
        _object = value;
    }

    /**
     * This method returns a CallAppPresentationAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getCallAppPresentationAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_PRESENTATION_ADDRESS) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a CallAppPresentationAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setCallAppPresentationAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallAppInfoType.CALL_APP_PRESENTATION_ADDRESS;
        _object = value;
    }

    /**
     * This method returns a CallAppTeleService
     * 
     * @return  a org.csapi.jr.se.cc.CallTeleService value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallTeleService getCallAppTeleService() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallAppInfoType.CALL_APP_TELE_SERVICE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallTeleService) _object);
    }

    /**
     * This method sets a CallAppTeleService
     * 
     * @param value a org.csapi.jr.se.cc.CallTeleService value
     */
    public void setCallAppTeleService(org.csapi.jr.se.cc.CallTeleService value) {
        _discriminator = CallAppInfoType.CALL_APP_TELE_SERVICE;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a CallAppInfoType value 
     */ 
    public void setUndefined(CallAppInfoType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof CallAppInfo)) {
            return false;
        } else {
            CallAppInfo callAppInfo= (CallAppInfo)o;
            if(!(this._object.equals(callAppInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(callAppInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallAppInfo

