//Source file: CallLoadControlListener.java
//Date: February 2007
//Generic Call Control for 1st draft ES 204 915-4-2 V1.1.1, DES/TISPAN-01032-04-2-OSA, Parlay 6.0

package org.csapi.jr.se.cc.gccs;

/**
 * This interface is to be implemented for receiving events issued by the CallLoadControl activity object.<BR>
 *
 */
public interface CallLoadControlListener extends java.util.EventListener {

    /**
     * Called due to a Gateway initiated call to the callOverloadEncountered() method on
     * the callback interface.
     *
     * @param  callOverloadEncounteredEvent  Reference to a CallOverloadEncounteredEvent event
     *        emmited from the impl or activity object.
     */
    void onCallOverloadEncounteredEvent(org.csapi.jr.se.cc.gccs.CallOverloadEncounteredEvent callOverloadEncounteredEvent);
    
    /**
     * Called due to a Gateway initiated call to the callOverloadCeased() method on
     * the callback interface.
     *
     * @param  callOverloadCeasedEvent  Reference to a CallOverloadCeasedEvent event
     *        emmited from the impl or activity object.
     */
    void onCallOverloadCeasedEvent(org.csapi.jr.se.cc.gccs.CallOverloadCeasedEvent callOverloadCeasedEvent);
    

}
