//Source file: RouteResEvent.java
//Date: February 2007
//Generic Call Control for 1st draft ES 204 915-4-2 V1.1.1, DES/TISPAN-01032-04-2-OSA, Parlay 6.0

package org.csapi.jr.se.cc.gccs;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the routeRes() method on the callback interface 
 * has occurred.<BR>
 *
 */
public final class RouteResEvent extends java.util.EventObject {

    /**
     * Constructor for the RouteResEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public RouteResEvent(java.lang.Object source,
        org.csapi.jr.se.cc.gccs.CallReport eventReport) {

        super(source);
      this.eventReport = eventReport;
 
    }

    org.csapi.jr.se.cc.gccs.CallReport eventReport;

    /**
     *  This method is used to retrieve the parameter value of 'eventReport' passed up
     *  from the Gateway in it's call to the routeRes() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'eventReport' used on creation of this event.
     */
    public org.csapi.jr.se.cc.gccs.CallReport getEventReport() {

        return this.eventReport;
    }
       
}

